'use client'
import {createContext} from 'react'
import {useForm, UseFormReturn} from 'react-hook-form'
import Center from '@/components/composites/purchase/short/center'
import Right from '@/components/composites/purchase/short/right'
import {Form} from '@/components/ui/form'
import * as z from 'zod'
import {zodResolver} from '@hookform/resolvers/zod'

// 定义表单验证架构
const schema = z.object({
  type: z.enum(['1', '2']).default('2'),
  live: z.enum(['180', '300', '600', '1200', '1800']),
  quota: z.number().min(10000, '购买数量不能少于10000个'),
  expire: z.enum(['7', '15', '30', '90', '180', '365']),
  daily_limit: z.number().min(2000, '每日限额不能少于2000个'),
  pay_type: z.enum(['wechat', 'alipay', 'balance']),
})

// 从架构中推断类型
export type Schema = z.infer<typeof schema>

type PurchaseFormContextType = {
  form: UseFormReturn<Schema>
  onSubmit?: () => void
}

export const PurchaseFormContext = createContext<PurchaseFormContextType | undefined>(undefined)

export type PurchaseFormProps = {}

export default function PurchaseForm(props: PurchaseFormProps) {
  const form = useForm<Schema>({
    resolver: zodResolver(schema),
    defaultValues: {
      type: '2', // 默认为包量套餐
      live: '180', // 分钟
      quota: 10_000, // >= 10000
      expire: '30', // 天
      daily_limit: 2_000, // >= 2000
      pay_type: 'balance', // 余额支付
    },
  })

  return (
    <Form form={form} className="flex flex-col lg:flex-row gap-4">
      <Center/>
      <Right/>
    </Form>
  )
}
